<template>
  <div>
    <h2>Posts page</h2>
    <my-input v-model="searchQuery" placeholder="Search..." class="search"/>
    <div class="app__btns">
      <my-button
      >
        Create post
      </my-button>
      <my-select
        v-model="selectedSort"
        :options="sortOptions"
      />
    </div>
    <my-dialog v-model:show="dialogVisible">
      <post-form />
    </my-dialog>
    <post-list
        :posts="sortedAndSearchedPosts"
        v-if="!isPostLoading"
    />
    <div v-else>Loading...</div>
  </div>
</template>

<script>
import { usePosts } from "@/hooks/UsePosts";
import useSortedPosts from "@/hooks/UseSortedPosts";
import useSortedAndSearchedPosts from "@/hooks/UseSortedAndSearchedPosts";
import PostForm from "@/components/PostForm";
import PostList from "@/components/PostList";
import MySelect from "@/components/UI/MySelect";

export default {
  components: { PostList, PostForm, MySelect },

  data() {
    return {
      dialogVisible: false,
      sortOptions: [
        {value: "title", name: "By name"},
        {value: "body", name: "By body"}
      ]
    };
  },
  methods: {
  },
  setup(props) {
    const { posts, totalPages, isPostLoading } = usePosts(10);
    const { selectedSort, sortedPosts } = useSortedPosts(posts);
    const { searchQuery, sortedAndSearchedPosts} = useSortedAndSearchedPosts(sortedPosts);

    return {
      posts, totalPages, isPostLoading, selectedSort, sortedPosts, searchQuery, sortedAndSearchedPosts
    }
  }
}
</script>

<style scoped>
.app__btns {
  display: flex;
  justify-content: space-between;
  margin: 15px 0;
}
.search {
  width: 100%;
}
</style>
